﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BNFUP.Interfaces;

namespace BNFUP.Controls
{
    public class RuleItemSelector : IEquatable<RuleItemSelector>, IComparable<RuleItemSelector>
    {
        public RuleItemSelector(IRuleItem item)
        {
            Item = item;
        }
        public IRuleItem Item { get; set; }
        public override string ToString()
        {
            if (Item != null)
            {
                return Item.Description;
            }
            return base.ToString();
        }
        public bool Equals(RuleItemSelector other)
        {
            return Item == other.Item;
        }
        public int CompareTo(RuleItemSelector other)
        {
            return string.Compare(ToString(), other.ToString(), true);
        }
    }
}
