﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using BNFUP.Properties;
using BNFUP.Rules;
using BNFUP.Interfaces;

namespace BNFUP.Controls
{
    public partial class dlgItems : Form
    {
        protected RuleTable _rules = null;
        public dlgItems()
        {
            InitializeComponent();
            Text = Resources.TTL_NEWITEM;
            bOK.Text = Resources.BTN_OK;
            bCancel.Text = Resources.BTN_CANCEL;
            lInsert.Text = Resources.LAB_INSERTAT;
        }

        public RuleTable Rules
        {
            get
            {
                return _rules;
            }
            set
            {
                _rules = value;
                LoadItems();
            }
        }
        public int InsertTop
        {
            get
            {
                return (int)udInsert.Maximum;
            }
            set
            {
                udInsert.Maximum = value;
                udInsert.Value = value;
                lInsert.Visible = true;
                udInsert.Visible = true;
            }
        }
        public int InsertPos
        {
            get
            {
                return (int)udInsert.Value;
            }
        } 
        public IEditableItem ListOwner { get; set; }
        public IRuleItem SelectedObject
        {
            get
            {
                RuleItemSelector rs = lbItems.SelectedItem as RuleItemSelector;
                if (rs != null)
                {
                    return rs.Item;
                }
                return null;
            }
        }
        private void LoadItems()
        {
            lbItems.Items.Clear();
            if (_rules != null)
            {
                foreach (Type t in _rules.ItemTypes)
                {
                    if (ListOwner.ValidateType(t, true))
                    {
                        IRuleItem ir = (IRuleItem)t.GetConstructor(Type.EmptyTypes).Invoke(null);
                        lbItems.Items.Add(new RuleItemSelector(ir));
                    }
                }
                foreach (IRuleItem ri in _rules.SimpleItems)
                {
                    if (!lbItems.Items.Contains(ri) && ListOwner.ValidateType(ri.GetType(), false))
                    {
                        lbItems.Items.Add(new RuleItemSelector(ri));
                    }
                }
                if (ListOwner.ValidateType(typeof(RuleBase), false))
                {
                    foreach (RuleBase rb in _rules.Rules)
                    {
                        lbItems.Items.Add(new RuleItemSelector(rb));
                    }
                }
            }
        }

        private void lbItems_SizeChanged(object sender, EventArgs e)
        {
            lbItems.ColumnWidth = lbItems.Width / 2;
        }
    }
}
