﻿using System;
using BNFUP.Properties;

namespace BNFUP.Exceptions
{
    public class InvalidTokenException : Exception
    {
        public InvalidTokenException(string token, int line, int position) : base(Resources.ERR_INVALIDTOKEN)
        {
            Token = token;
            Line = line;
            Position = position;
        }

        public InvalidTokenException(string token, int line, int position, string message) : base(message)
        {
            Token = token;
            Line = line;
            Position = position;
        }

        public string Token { get; private set; }
        public int Line { get;  private set; }
        public int Position { get; private set; }
    }
}
