﻿using System.Windows.Forms;

namespace BNFUP.Interfaces
{
    /// <summary>
    /// This interface must be implemented by all the objects that the BNFUP manages
    /// </summary>
    public interface ICompilableObject
    {
        /// <summary>
        /// Gets or sets the text string that generates the object
        /// </summary>
        string Text { get; set; }
        /// <summary>
        /// Add a child item
        /// </summary>
        /// <param name="item">Item to add</param>
        /// <returns>True if the item is accepted</returns>
        bool AddItem(ICompilableObject item);
        /// <summary>
        /// Return a simplified version of the object
        /// </summary>
        /// <returns>A simplified version of the object</returns>
        ICompilableObject Simplify();
        /// <summary>
        /// Here you can implement object testing
        /// </summary>
        /// <param name="fmain">Parent form</param>
        void Test(Form fmain);
    }
}
