﻿namespace BNFUP.Interfaces
{
    /// <summary>
    /// This interface must be implemented by the object responsible of create the compilable objects
    /// </summary>
    public interface ICompilableObjectFactory
    {
        /// <summary>
        /// This is the main object, which results of the compilation
        /// </summary>
        ICompilableObject Object { get; }
        /// <summary>
        /// Here you can initialice before the compilation
        /// </summary>
        void Init();
        /// <summary>
        /// Create a new object
        /// </summary>
        /// <param name="ctype">Key to select the type of object to create</param>
        /// <param name="item">Item which has raised the object creation</param>
        /// <returns>The new object created</returns>
        ICompilableObject CreateObject(string ctype, IRuleItem item);        
    }
}
