﻿using System.Drawing;

namespace BNFUP.Interfaces
{
    /// <summary>
    /// Used to draw the complete rules, in the form <rule>::=<rule items>
    /// </summary>
    public interface IRuleDrawing
    {
        /// <summary>
        /// Returns the size of the entire rule, using the provided fonts
        /// </summary>
        /// <param name="gr">Graphics object for drawing</param>
        /// <param name="fextra">Font used with extra characters</param>
        /// <param name="fmain">Font used with the main elements</param>
        /// <returns>Width and height of the rule in a SizeF struct</returns>
        SizeF MeasureRule(Graphics gr, Font fextra, Font fmain);
        /// <summary>
        /// Draws the rentire rule, using the provided fonts
        /// </summary>
        /// <param name="gr">Graphics object for drawing</param>
        /// <param name="x">Horizontal position</param>
        /// <param name="y">Vertical position</param>
        /// <param name="fextra">Font used with extra characters</param>
        /// <param name="fmain">Font used with the main elements</param>
        void DrawRule(Graphics gr, float x, float y, Font fextra, Font fmain);
    }
}
