﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BNFUP.Interfaces
{
    /// <summary>
    /// Clipboard implementation to deal with IRuleItem objects
    /// </summary>
    public interface IRuleItemClipboard
    {
        /// <summary>
        /// Indicates if the clipboard contains an object
        /// </summary>
        bool ContainsData { get; }
        /// <summary>
        /// Stores an object in the clipboard
        /// </summary>
        /// <param name="data">IRuleItem object to be stored</param>
        void SetData(IRuleItem data);
        /// <summary>
        /// Retrieves an object from the clipboard
        /// </summary>
        /// <returns>OBject contained in the clipboard</returns>
        IRuleItem GetData();
    }
}
