﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using BNFUP.Interfaces;

namespace BNFUP.Rules
{
    [Serializable]
    public class SimpleRuleItemList : List<IRuleItem>
    {
        public SimpleRuleItemList()
        {
        }
        [Browsable(false)]
        public new int Capacity
        {
            get
            {
                return base.Capacity;
            }
            set
            {
                base.Capacity = value;
            }
        }
        [Browsable(false)]
        public new int Count
        {
            get
            {
                return base.Count;
            }
        }
        public IRuleItem GetByName(string name)
        {
            foreach (IRuleItem ri in this)
            {
                if (ri is ItemBase) 
                {
                    if ((ri as ItemBase).ID == name)
                    {
                        return ri;
                    }
                }
            }
            return null;
        }
        public Token AddNewToken(Token token)
        {
            foreach (IRuleItem ri in this)
            {
                if (ri is Token)
                {
                    if ((ri as Token).Name == token.Name)
                    {
                        return ri as Token;
                    }
                }
            }
            Add(token);
            return token;
        }
        public CharacterSet AddNewCharacterSet(CharacterSet chset)
        {
            foreach (IRuleItem ri in this)
            {
                if (ri is CharacterSet)
                {
                    if ((ri as CharacterSet).ChSet == chset.ChSet)
                    {
                        return ri as CharacterSet;
                    }
                }
            }
            Add(chset);
            return chset;
        }
    }
}
