﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CellularAutomata.Interfaces;
using CellularAutomata.Properties;

namespace CellularAutomata.Automata
{
    [Serializable]
    public class BasicCellProvider : ICACellProvider
    {
        public BasicCellProvider()
        {
        }
        public override string ToString()
        {
            return UIResources.CPN_BASICCP;
        }
        #region ICACellProvider
        public IEnumerable<Type> CellTypes
        {
            get
            {
                yield return typeof(BasicCell);
                yield break;
            }
        }
        public ICACell GetCell(Type celltype, int initial)
        {
            return new BasicCell()
            {
                ActualState = initial
            };
        }
        #endregion
    }
}
