﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CellularAutomata.Interfaces
{
    /// <summary>
    /// Cellular automata cell provider
    /// </summary>
    public interface ICACellProvider
    {
        /// <summary>
        /// Enumerates the types of cell managed by the cell provider
        /// </summary>
        IEnumerable<Type> CellTypes { get; }
        /// <summary>
        /// Build a cell object
        /// </summary>
        /// <param name="celltype">Type of the cell</param>
        /// <param name="initial">Index of the initial state</param>
        /// <returns>Cell object as an ICACell interface</returns>
        ICACell GetCell(Type celltype, int initial);        
    }
}
