﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CommonObjects.Interfaces;

namespace CellularAutomata.Interfaces
{
    public interface ICAStateProvider
    {
        string UID { get; }
        string Name { get; set; }
        int Count { get; }
        IPropertyProvider PropertyProvider { get; set; }
        IEnumerable<ICAState> States { get; }
        Type DefaultStateType { get; set; }
        ICAState GetState(string name);
        ICAState GetState(int index);
        int IndexOf(ICAState s);
        int IndexOf(string name);
        bool ExistsState(string name);
        void AddState(ICAState s);
        void AddStates(IEnumerable<ICAState> ss);
        void RemoveState(string name);
        void RemoveState(ICAState s);
        void ChangeState(string name, ICAState s);
        ICAState CreateState(string name);
    }
}
