﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using CommonObjects.Interfaces;
using CommonObjects.Utils;

namespace CommonObjects.Expressions
{
    [Serializable]
    public class ArithmeticValue : ArithmeticArgument
    {
        [NonSerialized]
        private Random _runi = new Random();
        [NonSerialized]
        private RandomNormal _rnorm = new RandomNormal(5000, 0, 6, 0, 1);

        public ArithmeticValue() : base()
        {
        }
        public override int AsInt
        {
            get
            {
                switch (_text.ToLower())
                {
                    case "$pi":
                        return 3;
                    case "$e":
                        return 2;
                    case "$runi":
                        return 0;
                    case "$rnorm":
                        return 0;
                    default:
                        throw new NotImplementedException();
                }
            }
        }
        public override double AsDouble
        {
            get
            {
                switch (_text.ToLower())
                {
                    case "$pi":
                        return Math.PI;
                    case "$e":
                        return Math.E;
                    case "$runi":
                        return _runi.NextDouble();
                    case "$rnorm":
                        return _rnorm.NextValue();
                    default:
                        throw new NotImplementedException();
                }
            }
        }
        public override Color AsColor
        {
            get
            {
                throw new NotImplementedException();
            }
        }
        public override ExprType PreferredType
        {
            get
            {
                return ExprType.Double;
            }
        }
    }
}
