﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using BNFUP.Interfaces;
using CommonObjects.Interfaces;

namespace CommonObjects.Expressions
{
    [Serializable]
    public abstract class Identifier : ICompilableObject
    {
        protected string _text;
        public Identifier()
        {
        }
        #region ICompilableObject
        public abstract string Text { get; set; }
        public bool AddItem(ICompilableObject item)
        {
            return false;
        }
        public ICompilableObject Simplify()
        {
            return this;
        }
        public void Test(Form parent)
        {
        }
        #endregion
        public override string ToString()
        {
            return "Identifier: " + _text;
        }
    }
    [Serializable]
    public class VarIdentifier : Identifier
    {
        public VarIdentifier() : base()
        {
        }
        public override string Text
        {
            get
            {
                return _text;
            }
            set
            {
                _text = value.Substring(1);
            }
        }
    }
    [Serializable]
    public class PropIdentifier : Identifier
    {
        public PropIdentifier() : base()
        {
        }
        public override string Text
        {
            get
            {
                return _text;
            }
            set
            {
                _text = value.Substring(1);
            }
        }
    }
}
