﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using BNFUP.Interfaces;
using CommonObjects.Interfaces;
using CommonObjects.Utils;

namespace CommonObjects.Expressions
{
    [Serializable]
    public class IteratorProperty : UniversalArgument
    {
        private ExprType _typeDef = ExprType.None;

        public IteratorProperty() : base()
        {
        }
        public override string Text
        {
            get
            {
                return base.Text;
            }

            set
            {
            }
        }
        public override string AsText
        {
            get
            {
                return ";\\" + _text + ":" + TypedefText.AsText(_typeDef);
            }
        }
        public override bool AddItem(ICompilableObject item)
        {
            if ((item is PropertyReference) && string.IsNullOrEmpty(_text))
            {
                _text = item.Text;
                _typeDef = (item as PropertyReference).PreferredType;
                return true;
            }
            return false;
        }
        public override int AsInt
        {
            get
            {
                return _provider.GetIteratorPropertyValue(_text).AsInt;
            }
        }
        public override double AsDouble
        {
            get
            {
                return _provider.GetIteratorPropertyValue(_text).AsDouble;
            }
        }
        public override Color AsColor
        {
            get
            {
                return _provider.GetIteratorPropertyValue(_text).AsColor;
            }
        }
        public override bool AsBool
        {
            get
            {
                return _provider.GetIteratorPropertyValue(_text).AsBool;
            }
        }
        public override string AsString
        {
            get
            {
                return _provider.GetIteratorPropertyValue(_text).AsString;
            }
        }
        public override ExprType PreferredType
        {
            get
            {
                return _typeDef;
            }
        }
    }
}
