﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BNFUP.Interfaces;
using CommonObjects.Interfaces;

namespace CommonObjects.Expressions
{
    [Serializable]
    public class StringLiteral : StringArgument
    {
        public StringLiteral() : base()
        {
        }
        public override string AsText
        {
            get
            {
                return "\"" + _text + "\"";
            }
        }
        public override string AsString
        {
            get
            {
                return _text;
            }
        }
        public override string Text
        {
            get
            {
                return base.Text;
            }
            set
            {
                _text = value;
                if (_text.StartsWith("\""))
                {
                    _text = _text.Substring(1);
                }
                if (_text.EndsWith("\""))
                {
                    _text = _text.Substring(0, _text.Length - 1);
                }
            }
        }
        public override ExprType PreferredType
        {
            get
            {
                return ExprType.String;
            }
        }
    }
}
