﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BNFUP.Interfaces;
using CommonObjects.Interfaces;

namespace CommonObjects.Expressions
{
    [Serializable]
    public class TypeDef : ICompilableObject
    {
        private string _text;

        public TypeDef()
        {
        }
        public ExprType TypeDefined
        {
            get
            {
                switch (_text.ToLower())
                {
                    case "int":
                        return ExprType.Int;
                    case "double":
                        return ExprType.Double;
                    case "bool":
                        return ExprType.Bool;
                    case "string":
                        return ExprType.String;
                    default:
                        throw new NotImplementedException();
                }
            }
        }
        #region ICompilableObject
        public string Text
        {
            get
            {
                return _text;
            }
            set
            {
                _text = value;
            }
        }
        public bool AddItem(ICompilableObject item)
        {
            return false;
        }
        public ICompilableObject Simplify()
        {
            return this;
        }
        public void Test(Form parent)
        {
        }
        #endregion
    }
}
