﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace CommonObjects.Interfaces
{
    public enum ExprType
    {
        None, Int, Double, String, Bool, Color
    }
    /// <summary>
    /// Presents an expression as a variant value
    /// </summary>
    public interface IExpressionValue
    {
        /// <summary>
        /// Gets or sets the provider for the values of properties and variables
        /// </summary>
        IValueProvider ValueProvider { get; set; }
        /// <summary>
        /// Gets the expression result as an integer
        /// </summary>
        int AsInt { get; }
        /// <summary>
        /// Gets the expression result as a double
        /// </summary>
        double AsDouble { get; }
        /// <summary>
        /// Gets the expression result as a string
        /// </summary>
        string AsString { get; }
        /// <summary>
        /// Gets the expression result as a boolean
        /// </summary>
        bool AsBool { get; }
        /// <summary>
        /// Gets the expression result as a Color
        /// </summary>
        Color AsColor { get; }
        /// <summary>
        /// Gets the expression real value type
        /// </summary>
        ExprType PreferredType { get; }
    }
}
