﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CommonObjects.Interfaces;
using CellularAutomata.Interfaces;

namespace WinCA.Interfaces
{
    public class StateChangeEventArgs : EventArgs
    {
        [Flags]
        public enum Change
        {
            Added = 1, Deleted = 2, NameChanged = 4
        }
        public StateChangeEventArgs(ICAStateProvider p, ICAState state, Change chg, string oldn)
        {
            Provider = p;
            State = state;
            ChangeType = chg;
            OldName = oldn;
        }
        public ICAStateProvider Provider { get; private set; }
        public ICAState State { get; private set; }
        public Change ChangeType { get; private set; }
        public string OldName { get; private set; }
    }
    public delegate void CAStateChangeEventHandler(object sender, StateChangeEventArgs e);
    public interface ICAStateManager
    {
        event CAStateChangeEventHandler StateChanged;
        ICAStateProvider Provider { get; set; }
        IPropertyProvider VariableProvider { get; }
        IMainForm MainForm { get; set; }
    }
}
