﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CommonObjects.Interfaces;

namespace WinCA.Interfaces
{
    public class PropertyChangeEventArgs : EventArgs
    {
        [Flags]
        public enum Change
        {
            Added = 1, Deleted = 2, TypeChanged = 4, NameChanged = 8
        }
        public PropertyChangeEventArgs(IObjectProperty p, IPropertyProvider pp, Change chg, string oldn)
        {
            Provider = pp;
            Property = p;
            ChangeType = chg;
            OldName = oldn;
        }
        public IPropertyProvider Provider { get; private set; }
        public IObjectProperty Property { get; private set; }
        public Change ChangeType { get; private set; }
        public string OldName { get; private set; }
    }
    public delegate void PropertyChangeEventHandler(object sender, PropertyChangeEventArgs e);
    public interface IPropertyManager
    {
        event PropertyChangeEventHandler PropertyChanged;
        IPropertyProvider ConstantProvider { get; set; }
        IPropertyProvider VariableProvider { get; set; }
        IMainForm MainForm { get; set; }
    }
}
